'''
    Bad Lip Reading Add-on

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

from resources.lib import Addon, blr
import sys, os, urllib, urllib2
import json
import xbmc, xbmcgui, xbmcplugin, xbmcaddon

import liveresolver

addon = xbmcaddon.Addon()
addonname = addon.getAddonInfo('name')
addonid = addon.getAddonInfo('id')
plugin_path = xbmcaddon.Addon(id=addonid).getAddonInfo('path')

Addon.plugin_url = sys.argv[0]
Addon.plugin_handle = int(sys.argv[1])
Addon.plugin_queries = Addon.parse_query(sys.argv[2][1:])

dlg = xbmcgui.Dialog()

Addon.log('plugin url: ' + Addon.plugin_url)
Addon.log('plugin queries: ' + str(Addon.plugin_queries))
Addon.log('plugin handle: ' + str(Addon.plugin_handle)) 

mode = Addon.plugin_queries['mode']

if mode == 'main':
    channels = blr.Blr().build_main()
    if channels:
        for c in channels:
            Addon.add_directory({'mode': c['title']}, c['channel'])

if mode == 'STAR WARS':
    channels = blr.Blr().get_channels(mode)
    if channels:
        for c in sorted(channels):
            channel = c['channel'];
            videoId = c['videoId'];
            rURL = "plugin://plugin.video.blr/?channel=" + channel + "&id=" + mode + "&videoId=" + videoId + "&mode=play&rand=" + Addon.random_generator()
            logo = c['img']
            cm_refresh = (Addon.get_string(6000), 
                      'XBMC.RunPlugin(%s/?mode=refresh)' % 
                           (Addon.plugin_url))
            cm_menu = [cm_refresh]
           
            Addon.add_video_item(rURL,
                                 {'title': channel},
                                 img=logo, playable=True, cm=cm_menu, cm_replace=True)

if mode == 'NFL':
    channels = blr.Blr().get_channels(mode)
    if channels:
        for c in sorted(channels):
            channel = c['channel'];
            videoId = c['videoId'];
            rURL = "plugin://plugin.video.blr/?channel=" + channel + "&id=" + mode + "&videoId=" + videoId + "&mode=play&rand=" + Addon.random_generator()
            logo = c['img']
            cm_refresh = (Addon.get_string(6000), 
                      'XBMC.RunPlugin(%s/?mode=refresh)' % 
                           (Addon.plugin_url))
            cm_menu = [cm_refresh]
           
            Addon.add_video_item(rURL,
                                 {'title': channel},
                                 img=logo, playable=True, cm=cm_menu, cm_replace=True)

if mode == 'POLITICAL SOUNDBITES':
    channels = blr.Blr().get_channels(mode)
    if channels:
        for c in sorted(channels):
            channel = c['channel'];
            videoId = c['videoId'];
            rURL = "plugin://plugin.video.blr/?channel=" + channel + "&id=" + mode + "&videoId=" + videoId + "&mode=play&rand=" + Addon.random_generator()
            logo = c['img']
            cm_refresh = (Addon.get_string(6000), 
                      'XBMC.RunPlugin(%s/?mode=refresh)' % 
                           (Addon.plugin_url))
            cm_menu = [cm_refresh]
           
            Addon.add_video_item(rURL,
                                 {'title': channel},
                                 img=logo, playable=True, cm=cm_menu, cm_replace=True)

if mode == 'MOVIES AND TV':
    channels = blr.Blr().get_channels(mode)
    if channels:
        for c in sorted(channels):
            channel = c['channel'];
            videoId = c['videoId'];
            rURL = "plugin://plugin.video.blr/?channel=" + channel + "&id=" + mode + "&videoId=" + videoId + "&mode=play&rand=" + Addon.random_generator()
            logo = c['img']
            cm_refresh = (Addon.get_string(6000), 
                      'XBMC.RunPlugin(%s/?mode=refresh)' % 
                           (Addon.plugin_url))
            cm_menu = [cm_refresh]
           
            Addon.add_video_item(rURL,
                                 {'title': channel},
                                 img=logo, playable=True, cm=cm_menu, cm_replace=True)

if mode == 'BLR MUSIC VIDEOS':
    channels = blr.Blr().get_channels(mode)
    if channels:
        for c in sorted(channels):
            channel = c['channel'];
            videoId = c['videoId'];
            rURL = "plugin://plugin.video.blr/?channel=" + channel + "&id=" + mode + "&videoId=" + videoId + "&mode=play&rand=" + Addon.random_generator()
            logo = c['img']
            cm_refresh = (Addon.get_string(6000), 
                      'XBMC.RunPlugin(%s/?mode=refresh)' % 
                           (Addon.plugin_url))
            cm_menu = [cm_refresh]
           
            Addon.add_video_item(rURL,
                                 {'title': channel},
                                 img=logo, playable=True, cm=cm_menu, cm_replace=True)

elif mode == 'refresh':
    xbmc.executebuiltin('Container.Refresh')

elif mode=='play':
    videoId = Addon.plugin_queries['videoId']
    id = Addon.plugin_queries['id']
    channel = Addon.plugin_queries['channel']
    stream_status = blr.Blr()._get_json('/check.php', {'id': videoId})['status']
    if stream_status == 'true':
        Addon.log(channel)
        channels = []
        channels = blr.Blr().get_link(id)
        if channels:
            Addon.log(str(channels))
            for c in sorted(channels):
                if c['channel'] == channel:
                    url = c['url']
                    stream_url = liveresolver.resolve(url)
                    Addon.log(stream_url)
                    item = xbmcgui.ListItem(path=stream_url)
                    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
    else:
        dlg.ok(Addon.get_string(5000), '"' + channel + '"' + " " + Addon.get_string(7000))

Addon.end_of_directory()
